package codeOfValue;

import edu.rice.cs.mint.runtime.Code;
import edu.rice.cs.mint.runtime.MintSerializer;

import java.io.*;

import static codeOfValue.StagedDataTypes.*;

public class Runner extends util.ARunner<ValueFun,Value,Value> {
    public static void main(String[] args) throws IOException { new Runner().run(args); }
    
    public Value parseArgument(String arg) {
        try {
            Integer i = new Integer(arg);
            return new IntValue(i);
        }
        catch(NumberFormatException nfe) {
            return new BooleanValue(new Boolean(arg));
        }
    }

    public Value execute(ValueFun functionBody, Value arg) {
        return functionBody.apply(arg);
    }
}
