package simple_int;

import edu.rice.cs.mint.runtime.Code;
import edu.rice.cs.mint.runtime.MintSerializer;

import java.io.*;

import static simple_int.StagedLint.*;

public class Compiler extends util.ACompiler<Exp,IntFun> {
    public static void main(String[] args) throws IOException { new Compiler().run(args); }

    public Exp parse(String source) {
        return parser.LintParser.parse(Exp.class, source);
    }
    
    public Code<IntFun> getFunction(final Exp funBody) {
        return <| (IntFun) new IntFun() {
            public int apply(final int param) {
                return `(bindParameter(funBody, <|param|>));
            }
        } |>;
    }
}
