package simple_int;

import edu.rice.cs.mint.runtime.Code;
import edu.rice.cs.mint.runtime.MintSerializer;

import java.io.*;

import static simple_int.UnstagedLint.*;

public class Interpreter extends util.AInterpreter<Exp,Integer,Integer> {
    public static void main(String[] args) throws IOException { new Interpreter().run(args); }
    
    public Integer parseArgument(String arg) {
        return new Integer(arg);
    }
    
    public Exp parse(String source) {
        return parser.LintParser.parse(Exp.class, source);
    }
    
    public Integer interpret(Exp functionBody, Integer arg) {
        return new Program(new App("f", new Int(arg)),
                           new Declaration("f", "n", functionBody)).peval(env0, fenv0);
    }
}
