package simple_int;

import edu.rice.cs.mint.runtime.Code;
import edu.rice.cs.mint.runtime.MintSerializer;

import java.io.*;

import static simple_int.StagedLint.*;

public class TenPlusX {
    public static void main(String[] args) throws IOException {
        Code<IntFun> tenPlusXCode = <| (IntFun) new IntFun() {
            public int apply(final int x) {
                return `(new Add(new Int(10), new Int(<| x |>)).
                             eval(env0, fenv0));
            }
        } |>;
        IntFun tenPlusX = tenPlusXCode.run();
        int j = tenPlusX.apply(20); // j = 10 + 20 = 30 

        System.out.println(tenPlusXCode);
        System.out.println(j);
    }
}
